com.smartgwt.client.widgets.menu

## Class Menu

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.widgets.grid.ListGrid
              - - com.smartgwt.client.widgets.menu.Menu

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, DataBoundComponent, HasClickHandlers, HasDoubleClickHandlers, HasDragCompleteHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropCompleteHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFetchDataHandlers, HasFocusChangedHandlers, HasFormulaUpdatedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasBodyKeyPressHandlers, HasCellClickHandlers, HasCellContextClickHandlers, HasCellDoubleClickHandlers, HasCellHoverHandlers, HasCellMouseDownHandlers, HasCellMouseUpHandlers, HasCellOutHandlers, HasCellOverHandlers, HasCellSavedHandlers, HasCellSelectionChangedHandlers, HasCellValueHoverHandlers, HasDataArrivedHandlers, HasDrawAreaChangedHandlers, HasEditCompleteHandlers, HasEditFailedHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFieldStateChangedHandlers, HasFilterEditorSubmitHandlers, HasGroupByCompleteHandlers, HasGroupByHandlers, HasGroupStateChangedHandlers, HasHeaderClickHandlers, HasHeaderDoubleClickHandlers, HasHeaderHoverHandlers, HasHilitesChangedHandlers, HasRecordClickHandlers, HasRecordCollapseHandlers, HasRecordDoubleClickHandlers, HasRecordDropHandlers, HasRecordExpandHandlers, HasRemoveRecordClickHandlers, HasRowContextClickHandlers, HasRowEditorEnterHandlers, HasRowEditorExitHandlers, HasRowHoverHandlers, HasRowMouseDownHandlers, HasRowMouseUpHandlers, HasRowOutHandlers, HasRowOverHandlers, HasSelectionChangedHandlers, HasSelectionUpdatedHandlers, HasSortChangedHandlers, HasSorterClickHandlers, HasSorterContextClickHandlers, HasViewStateChangedHandlers, HasItemClickHandlers

      public class Menu
      extends ListGrid
      implements HasItemClickHandlers

  The Menu widget class implements interactive menu widgets, with optional icons, submenus, and shortcut keys.

  A Menu is initialized with an Array of items, specified as menu.data, each of which represents one row in the menu's display and specifies the action to take when that menu item is selected.

  Generally to create a context menu for a component, provide a Menu instance for the `contextMenu` property. Note that some components have special context menu support because they have distinct regions or because they have a default set of context menu actions available.

  If you want a button that pops up a menu when clicked, or a bar of such buttons, see the MenuButton and MenuBar classes.

  See Also:
    `com.smartgwt.client.widgets.menu.Menu#getData`, `Canvas.getContextMenu()`, `MenuButton`, `MenuBar`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, id, isElementSet, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Menu()`
    `Menu(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addItem(MenuItem item)`
    `void` | `addItem(MenuItem item, int index)`
    `com.google.gwt.event.shared.HandlerRegistration` | `addItemClickHandler(ItemClickHandler handler)` Add a itemClick handler.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.Boolean` | `getAlternateRecordStyles()` Explicitly disable alternateRecordStyles at the menu level by default so setting to true for all ListGrids will not impact menus' appearance.
    `java.lang.Boolean` | `getAutoDismiss()` When false, when a menu item is chosen (via mouse click or keyboard), the menu is not automatically hidden, staying in place for further interactivity
    `java.lang.Boolean` | `getAutoDismissOnBlur()` When false, when a user clicks outside the menu, or hits the Escape key, this menu will not be automatically hidden, staying in place for further interactivity.
    `java.lang.Boolean` | `getAutoDraw()` Menus will not draw on initialization, until they're explicitly show()n
    `java.lang.String` | `getBaseStyle()` CSS style for a normal cell
    `java.lang.String` | `getBodyStyleName()` CSS style used for the body of this menu when there is no icon field.
    `java.lang.Boolean` | `getCanSelectParentItems()` If true, clicking or pressing Enter on a menu item that has a submenu will select that item (with standard behavior of hiding the menus, calling click handlers, etc) instead of showing the submenu.
    `java.lang.Boolean` | `getCascadeAutoDismiss()` When true any generated submenus will inherit `autoDismiss` from this menu.
    `int` | `getCellHeight()` The height of each item in the menu, in pixels.
    `DataSource` | `getDataSource()` Optional DataSource to fetch menuItems and submenus from, instead of using `data`/menu.items.
    `int` | `getDefaultWidth()` The default menu width.
    `java.lang.String` | `getEmptyMessage()` Message to show when a menu is shown with no items.
    `java.lang.Boolean` | `getFetchSubmenus()` When using a Tree or hierarchical DataSource as the menu's data, submenus are automatically generated from child nodes.
    `java.lang.String` | `getIconBodyStyleName()` If set, the CSS style used for the body of this menu when there is an icon field.
    `int` | `getIconHeight()` The default height applied to custom icons in this menu.
    `int` | `getIconWidth()` The default width applied to custom icons in this menu.
    `MenuItem` | `getItem(int item)` Get a particular MenuItem by index.
    `int` | `getItemNum(MenuItem item)` Given a MenuItem, return it's index in the items array.
    `MenuItem[]` | `getItems()` Return the menu items.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()`
    `java.lang.Integer` | `getMenuButtonWidth()` For a menu that has a `MenuButton` generated for it automatically (for example when included in a `MenuBar`, the width that the MenuButton should have.
    `static Menu` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.String` | `getShowAnimationEffect()` When this menu is shown how should it animate into view? By default the menu will just show at the specified size/position.
    `java.lang.Boolean` | `getShowIcons()` A boolean, indicating whether the checkmark/custom icon column should be displayed.
    `java.lang.Boolean` | `getShowKeys()` A boolean, indicating whether the shortcut key column should be displayed.
    `java.lang.Boolean` | `getShowSubmenus()` A boolean, indicating whether the submenu indicator column should be displayed.
    `java.lang.String` | `getSubmenuConstructor()` When using a Tree or hierarchical DataSource as the menu's data, optional subclass of Menu that should be used when generating submenus.
    `java.lang.String` | `getSubmenuDirection()` Should submenus show up on our left or right.
    `Canvas` | `getTarget()` Optional target canvas for this menu.
    `protected Menu` | `getTestInstance()`
    `java.lang.Boolean` | `getUseKeys()` A boolean indicating whether this menu should use shortcut keys.
    `static void` | `hideAllMenus()` Hide all menus that are currently open.
    `void` | `hideContextMenu()` Hide the context menu - alias for hide()
    `protected void` | `onInit_ListGrid()`
    `void` | `removeItem(MenuItem item)`
    `void` | `setAlternateRecordStyles(java.lang.Boolean alternateRecordStyles)` Explicitly disable alternateRecordStyles at the menu level by default so setting to true for all ListGrids will not impact menus' appearance.
    `void` | `setAutoDismiss(java.lang.Boolean autoDismiss)` When false, when a menu item is chosen (via mouse click or keyboard), the menu is not automatically hidden, staying in place for further interactivity
    `void` | `setAutoDismissOnBlur(java.lang.Boolean autoDismissOnBlur)` When false, when a user clicks outside the menu, or hits the Escape key, this menu will not be automatically hidden, staying in place for further interactivity.
    `void` | `setAutoDraw(java.lang.Boolean autoDraw)` Menus will not draw on initialization, until they're explicitly show()n
    `void` | `setBaseStyle(java.lang.String baseStyle)` CSS style for a normal cell
    `void` | `setBodyStyleName(java.lang.String bodyStyleName)` CSS style used for the body of this menu when there is no icon field.
    `void` | `setCanSelectParentItems(java.lang.Boolean canSelectParentItems)` If true, clicking or pressing Enter on a menu item that has a submenu will select that item (with standard behavior of hiding the menus, calling click handlers, etc) instead of showing the submenu.
    `void` | `setCascadeAutoDismiss(java.lang.Boolean cascadeAutoDismiss)` When true any generated submenus will inherit `autoDismiss` from this menu.
    `void` | `setCellHeight(int cellHeight)` The height of each item in the menu, in pixels.
    `void` | `setData(MenuItem... data)` An array of menuItem objects, specifying the menu items this menu should show.
    `void` | `setData(Record[] data)` An array of Record objects, specifying the data to be used to populate the DataBoundComponent.
    `void` | `setData(RecordList data)` An List of Record objects, specifying the data to be used to populate the DataBoundComponent.
    `void` | `setData(Tree data)` Display a hierarchical set of menu items and submenus based on a Tree of data.
    `void` | `setDataSource(DataSource dataSource)` Optional DataSource to fetch menuItems and submenus from, instead of using `data`/menu.items.
    `static void` | `setDefaultProperties(Menu menuProperties)` Class level method to set the default properties of this class.
    `void` | `setDefaultWidth(int defaultWidth)` The default menu width.
    `void` | `setEmptyMessage(java.lang.String emptyMessage)` Message to show when a menu is shown with no items.
    `void` | `setFetchSubmenus(java.lang.Boolean fetchSubmenus)` When using a Tree or hierarchical DataSource as the menu's data, submenus are automatically generated from child nodes.
    `void` | `setIconBodyStyleName(java.lang.String iconBodyStyleName)` If set, the CSS style used for the body of this menu when there is an icon field.
    `void` | `setIconHeight(int iconHeight)` The default height applied to custom icons in this menu.
    `void` | `setIconWidth(int iconWidth)` The default width applied to custom icons in this menu.
    `java.lang.Boolean` | `setItemChecked(int item)` Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemChecked(int item, boolean newState)` Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemChecked(MenuItem item)` Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemChecked(MenuItem item, boolean newState)` Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemEnabled(int item)` Enables or disables the menu item according to the value of newState, and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemEnabled(int item, boolean newState)` Enables or disables the menu item according to the value of newState, and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemEnabled(MenuItem item)` Enables or disables the menu item according to the value of newState, and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemEnabled(MenuItem item, boolean newState)` Enables or disables the menu item according to the value of newState, and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemIcon(int item, java.lang.String newIcon)` Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemIcon(int item, java.lang.String newIcon, java.lang.String newDisabledIcon)` Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemIcon(MenuItem item, java.lang.String newIcon)` Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemIcon(MenuItem item, java.lang.String newIcon, java.lang.String newDisabledIcon)` Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary.
    `void` | `setItemProperties(int item, MenuItem properties)` Set arbitrary properties for a particular menu item.
    `void` | `setItems(MenuItem... items)` Synonym for `data` Synonym for `setData(com.smartgwt.client.widgets.menu.MenuItem...)`.
    `java.lang.Boolean` | `setItemTitle(int item, java.lang.String newTitle)` Sets the title of a particular menu item to the string specified by newTitle and redraws the menu if necessary.
    `java.lang.Boolean` | `setItemTitle(MenuItem item, java.lang.String newTitle)` Sets the title of a particular menu item to the string specified by newTitle and redraws the menu if necessary.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.menu.MenuLogicalStructure s)`
    `void` | `setMenuButtonWidth(java.lang.Integer menuButtonWidth)` For a menu that has a `MenuButton` generated for it automatically (for example when included in a `MenuBar`, the width that the MenuButton should have.
    `void` | `setShowAnimationEffect(java.lang.String showAnimationEffect)` When this menu is shown how should it animate into view? By default the menu will just show at the specified size/position.
    `void` | `setShowIcons(java.lang.Boolean showIcons)` A boolean, indicating whether the checkmark/custom icon column should be displayed.
    `void` | `setShowKeys(java.lang.Boolean showKeys)` A boolean, indicating whether the shortcut key column should be displayed.
    `void` | `setShowSubmenus(java.lang.Boolean showSubmenus)` A boolean, indicating whether the submenu indicator column should be displayed.
    `void` | `setSubmenuConstructor(java.lang.String submenuConstructor)` When using a Tree or hierarchical DataSource as the menu's data, optional subclass of Menu that should be used when generating submenus.
    `void` | `setSubmenuDirection(java.lang.String submenuDirection)` Should submenus show up on our left or right.
    `void` | `setTarget(Canvas target)` Optional target canvas for this menu.
    `void` | `setTitle(java.lang.String title)` When used in a MenuBar, the title of the menu button create will be the title of the Menu.
    `void` | `setUseKeys(java.lang.Boolean useKeys)` A boolean indicating whether this menu should use shortcut keys.
    `java.lang.Boolean` | `showContextMenu()` Show this menu as a context menu, that is, immediately adjacent to the current mouse position.

    - ### Methods inherited from class com.smartgwt.client.widgets.grid.ListGrid

      `addBodyKeyPressHandler, addCellClickHandler, addCellContextClickHandler, addCellDoubleClickHandler, addCellHoverHandler, addCellMouseDownHandler, addCellMouseUpHandler, addCellOutHandler, addCellOverHandler, addCellSavedHandler, addCellSelectionChangedHandler, addCellValueHoverHandler, addData, addData, addData, addDataArrivedHandler, addDragCompleteHandler, addDrawAreaChangedHandler, addDropCompleteHandler, addEditCompleteHandler, addEditFailedHandler, addEditorEnterHandler, addEditorExitHandler, addEmbeddedComponent, addEmbeddedComponent, addEmbeddedComponent, addEmbeddedComponent, addFetchDataHandler, addFieldStateChangedHandler, addFilterEditorSubmitHandler, addFormulaField, addFormulaUpdatedHandler, addGroupByCompleteHandler, addGroupByHandler, addGroupStateChangedHandler, addHeaderClickHandler, addHeaderDoubleClickHandler, addHeaderHoverHandler, addHilitesChangedHandler, addRecordClickHandler, addRecordCollapseHandler, addRecordDoubleClickHandler, addRecordDropHandler, addRecordExpandHandler, addRemoveRecordClickHandler, addRowContextClickHandler, addRowEditorEnterHandler, addRowEditorExitHandler, addRowHoverHandler, addRowMouseDownHandler, addRowMouseUpHandler, addRowOutHandler, addRowOverHandler, addSelectionChangedHandler, addSelectionUpdatedHandler, addSort, addSortChangedHandler, addSorterClickHandler, addSorterContextClickHandler, addSummaryField, addViewStateChangedHandler, anySelected, applyCellData, applyRecordData, autoFitField, autoFitFields, cancelEditing, canEditCell, canExpandRecord, canSelectCell, canSelectRecord, cellHasChanges, cellHasErrors, cellHasErrors, cellValueHoverHTML, cellValueIsClipped, chartData, chartData, clearCriteria, clearCriteria, clearCriteria, clearEditValue, clearFieldError, clearFieldError, clearRowErrors, clearSort, closeRecord, collapseRecord, configureGrouping, createRecordComponent, deselectAllRecords, deselectRecord, deselectRecord, deselectRecords, deselectRecords, disableHilite, disableHiliting, discardAllEdits, discardAllEdits, discardEdits, discardEdits, editFields, editHilites, enableHilite, enableHilite, enableHiliting, enableHiliting, endEditing, expandRecord, exportClientData, exportClientData, exportData, exportData, fetchData, fetchData, fetchData, fetchData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fieldIsVisible, filterByEditor, filterData, filterData, filterData, filterData, find, findAll, findIndex, findNextIndex, findNextIndex, focusInFilterEditor, focusInFilterEditor, freezeField, freezeField, freezeFields, freezeFields, getAddDropValues, getAddFormulaFieldText, getAddOperation, getAddSummaryFieldText, getAdvancedFieldPickerThreshold, getAllEditRows, getAllFields, getAllowFilterExpressions, getAllowRowSpanning, getAlternateBodyStyleName, getAlternateRecordFrequency, getAlwaysShowEditors, getAnimateFolderEffect, getAnimateFolderMaxRows, getAnimateFolders, getAnimateFolderSpeed, getAnimateFolderTime, getAnimateRemoveRecord, getAnimateRemoveSpeed, getAnimateRemoveTime, getAnimateRollOver, getAnimateRollUnder, getAnimateSelection, getAnimateSelectionUnder, getApplyFormulaAfterSummary, getApplyRowNumberStyle, getArrowKeyAction, getAsynchGroupingPrompt, getAutoFetchAsFilter, getAutoFetchData, getAutoFetchDisplayMap, getAutoFetchTextMatchStyle, getAutoFitAllText, getAutoFitClipFields, getAutoFitData, getAutoFitExpandField, getAutoFitExtraRecords, getAutoFitFieldsFillViewport, getAutoFitFieldText, getAutoFitFieldWidths, getAutoFitHeaderHeights, getAutoFitIconFields, getAutoFitMaxColumns, getAutoFitMaxHeight, getAutoFitMaxRecords, getAutoFitMaxWidth, getAutoFitWidthApproach, getAutoSaveEdits, getAutoSizeHeaderSpans, getBackgroundComponent, getBadFormulaResultValue, getBaseStyle, getBody, getBodyBackgroundColor, getBodyOverflow, getBodyScrollLeft, getBodyScrollTop, getBooleanBaseStyle, getBooleanFalseImage, getBooleanImageHeight, getBooleanImageWidth, getBooleanPartialImage, getBooleanTrueImage, getCanAcceptDroppedRecords, getCanAddFormulaFields, getCanAddSummaryFields, getCanAutoFitFields, getCancelEditingConfirmationMessage, getCanCollapseGroup, getCanDragRecordsOut, getCanDragSelect, getCanDragSelectText, getCanDropInEmptyArea, getCanEdit, getCanEditFieldAttribute, getCanEditTitles, getCanExpandMultipleRecords, getCanExpandRecordProperty, getCanExpandRecords, getCanFreezeFields, getCanGroupBy, getCanHover, getCanMultiGroup, getCanMultiSort, getCanPickFields, getCanPickOmittedFields, getCanRemoveRecords, getCanReorderFields, getCanReorderRecords, getCanResizeFields, getCanSelectAll, getCanSelectCells, getCanSort, getCanTabToHeader, getCellCSSText, getCellErrors, getCellHoverComponent, getCellPadding, getCellRowSpan, getCellSelection, getCellStartRow, getCellStyle, getChartConstructor, getChartType, getCheckboxFieldFalseImage, getCheckboxFieldImageHeight, getCheckboxFieldImageWidth, getCheckboxFieldPartialImage, getCheckboxFieldTrueImage, getChildExpansionMode, getClearAllSortingText, getClearFilterText, getClearSortFieldText, getClipHeaderTitles, getConfigureGroupingText, getConfigureSortText, getConfirmCancelEditing, getConfirmDiscardEdits, getConfirmDiscardEditsMessage, getCriteria, getCurrentExpansionComponent, getCurrentExpansionComponent, getDataAsJSList, getDataAsRecordList, getDataFetchMode, getDataPageSize, getDateFormatter, getDatetimeFormatter, getDefaultFields, getDefaultFieldWidth, getDefaultFormattedFieldValue, getDefaultFormattedFieldValue, getDefaultFormattedFieldValue, getDefaultFormattedValue, getDeferRemoval, getDetailDS, getDetailField, getDiscardEditsSaveButtonTitle, getDisplayValue, getDisplayValue, getDisplayValue, getDisplayValue, getDisplayValue, getDragData, getDragDataAction, getDragTrackerMode, getDragTrackerStyle, getDragTrackerTitle, getDrawAheadRatio, getDrawAllMaxCells, getDrawArea, getDrawnRowHeight, getDrawnRows, getDropValues, getDuplicateDragMessage, getEditByCell, getEditCol, getEditedCell, getEditedCell, getEditedCell, getEditedCell, getEditedRecord, getEditEvent, getEditFailedBaseStyle, getEditFailedCSSText, getEditFormItem, getEditFormItem, getEditFormulaFieldText, getEditOnF2Keypress, getEditOnFocus, getEditPendingBaseStyle, getEditPendingCSSText, getEditRow, getEditSummaryFieldText, getEditValue, getEditValueAsBoolean, getEditValueAsDate, getEditValueAsFloat, getEditValueAsInt, getEditValueAsRecord, getEditValueAsRecordArray, getEditValueAsString, getEditValues, getEditValues, getEmptyCellValue, getEmptyMessageStyle, getEnforceVClipping, getEnterKeyEditAction, getEnumCriteriaAsInitialValues, getEscapeKeyEditAction, getEventColumn, getEventColumn, getEventRow, getEventRow, getExpansionCanEdit, getExpansionComponent, getExpansionDetailField, getExpansionDetailRelated, getExpansionDetails, getExpansionEditor, getExpansionEditorCollapseOnSave, getExpansionEditorSaveButton, getExpansionEditorSaveButtonTitle, getExpansionEditorSaveDialogPrompt, getExpansionEditorShowSaveDialog, getExpansionField, getExpansionFieldFalseImage, getExpansionFieldImageHeight, getExpansionFieldImageWidth, getExpansionFieldTrueImage, getExpansionLayout, getExpansionMode, getExpansionRelated, getExportAll, getExportFields, getExportRawValues, getFetchDelay, getFetchOperation, getField, getField, getFieldName, getFieldName, getFieldNum, getFieldPickerFieldProperties, getFieldPickerShowSampleValues, getFieldPickerWindow, getFields, getFieldState, getFieldVisibilitySubmenuTitle, getFieldWidth, getFilterButtonPrompt, getFilterButtonProperties, getFilterByCell, getFilterEditor, getFilterEditorCriteria, getFilterEditorCriteria, getFilterEditorHeight, getFilterLocalData, getFilterOnKeypress, getFixedFieldWidths, getFixedRecordHeights, getFocusRow, getFormulaBuilderSpanTitleSeparator, getFormulaFieldValue, getFreezeFieldText, getFreezeOnLeftText, getFreezeOnRightText, getFrozenBaseStyle, getFrozenHeaderBaseStyle, getFrozenHeaderTitleStyle, getGenerateClickOnEnter, getGenerateClickOnSpace, getGenerateDoubleClickOnEnter, getGenerateDoubleClickOnSpace, getGridComponents, getGridRenderer, getGridSummary, getGridSummaryData, getGridSummaryRecordProperty, getGroupByAsyncThreshold, getGroupByFields, getGroupByFieldSummaries, getGroupByMaxRecords, getGroupByText, getGroupIcon, getGroupIconSize, getGroupIndentSize, getGroupLeadingIndent, getGroupNodeBaseStyle, getGroupNodeStyle, getGroupState, getGroupSummaryRecordProperty, getGroupSummaryStyle, getGroupTitleColumnProperties, getGroupTitleField, getGroupTree, getHeader, getHeaderAutoFitEvent, getHeaderBackgroundColor, getHeaderBarStyle, getHeaderBaseStyle, getHeaderButtonProperties, getHeaderContextMenuItems, getHeaderHeight, getHeaderHoverAlign, getHeaderHoverHeight, getHeaderHoverOpacity, getHeaderHoverStyle, getHeaderHoverVAlign, getHeaderHoverWidth, getHeaderHoverWrap, getHeaderMenuButton, getHeaderMenuButtonHeight, getHeaderMenuButtonIcon, getHeaderMenuButtonIconHeight, getHeaderMenuButtonIconWidth, getHeaderMenuButtonWidth, getHeaderSpan, getHeaderSpanContextMenuItems, getHeaderSpanHeight, getHeaderTitleStyle, getHiliteCanReplaceValue, getHiliteEditorSpanTitleSeparator, getHiliteIconHeight, getHiliteIconLeftPadding, getHiliteIconPosition, getHiliteIconRightPadding, getHiliteIcons, getHiliteIconSize, getHiliteIconWidth, getHiliteProperty, getHiliteReplaceValueFieldTitle, getHilites, getHiliteState, getHoverMode, getHoverStyle, getImageSize, getIncludeHilitesInSummaryFields, getIncludeInSummaryProperty, getInitialCriteria, getInitialSort, getInstantScrollTrackRedraw, getInvalidSummaryValue, getIsGrouped, getIsSeparatorProperty, getLeaveScrollbarGap, getLinkTextProperty, getListEndEditAction, getLoadingDataMessage, getLoadingDataMessageStyle, getLoadingMessage, getLocateColumnsBy, getLocateRowsBy, getLongTextEditorThreshold, getLongTextEditorType, getMaxExpandedRecords, getMaxExpandedRecordsPrompt, getMinFieldWidth, getMissingSummaryFieldValue, getModalEditing, getNeverValidate, getNormalBaseStyle, getNormalCellHeight, getNullGroupTitle, getOfflineMessageStyle, getOriginalRecordList, getOriginalResultSet, getOriginBaseStyle, getPoolComponentsPerColumn, getPreventDuplicates, getPrintAutoFit, getPrintBaseStyle, getPrintHeaderStyle, getPrintMaxRows, getPrintWrapCells, getQuickDrawAheadRatio, getRecord, getRecordBaseStyleProperty, getRecordCanRemoveProperty, getRecordCanSelectProperty, getRecordComponent, getRecordComponent, getRecordComponentHeight, getRecordComponentPoolingMode, getRecordComponentPosition, getRecordDetailDSProperty, getRecordEditProperty, getRecordEnabledProperty, getRecordIndex, getRecordIndex, getRecordList, getRecords, getRecordSummaryBaseStyle, getRelatedDataSource, getRemovedCSSText, getRemoveFieldDefaults, getRemoveFieldProperties, getRemoveFieldTitle, getRemoveIcon, getRemoveIconSize, getRemoveOperation, getReselectOnUpdate, getReselectOnUpdateNotifications, getResizeFieldsInRealTime, getResultSet, getReverseRTLAlign, getRollOverCanvas, getRollUnderCanvas, getRowEndEditAction, getRowErrors, getRowHeight, getRowNumberField, getRowNumberStart, getRowNumberStyle, getRowPageTop, getRowSpan, getRowSpanSelectionMode, getRowTop, getSaveByCell, getSaveLocally, getSaveRequestProperties, getScreenReaderCellSeparator, getScreenReaderRowSeparator, getScrollRedrawDelay, getSelectedCellData, getSelectedRecord, getSelectedRecords, getSelectedRecords, getSelectedState, getSelectHeaderOnSort, getSelection, getSelection, getSelectionAppearance, getSelectionProperty, getSelectionType, getSelectOnEdit, getShowAllColumns, getShowAllRecords, getShowAsynchGroupingPrompt, getShowBackgroundComponents, getShowCellContextMenus, getShowClippedHeaderTitlesOnHover, getShowClippedValuesOnHover, getShowCollapsedGroupSummary, getShowComplexFields, getShowDetailFields, getShowEmptyMessage, getShowExpansionEditorSaveButton, getShowFilterEditor, getShowGridSummary, getShowGroupSummary, getShowGroupSummaryInHeader, getShowGroupTitleColumn, getShowHeader, getShowHeaderContextMenu, getShowHeaderMenuButton, getShowHeaderSpanTitlesInFormulaBuilder, getShowHeaderSpanTitlesInHiliteEditor, getShowHeaderSpanTitlesInSortEditor, getShowHiddenFields, getShowHilitesInGroupSummary, getShowHover, getShowHoverComponents, getShowRecordComponents, getShowRecordComponentsByCell, getShowRollOver, getShowRollOverCanvas, getShowRowNumbers, getShowSelectedStyle, getShowSelectionCanvas, getShowSortArrow, getShowSortNumerals, getShowTreeColumnPicker, getShrinkForFreeze, getSingleCellValueProperty, getSkinImgDir, getSort, getSortAscendingImage, getSortDescendingImage, getSortDirection, getSortEditorSpanTitleSeparator, getSorterButtonTitle, getSortField, getSortFieldAscendingText, getSortFieldCount, getSortFieldDescendingText, getSortNumeralHTML, getSortNumeralStyle, getSortSpecifier, getSortState, getStopOnErrors, getStyleName, getSummaryFieldValue, getSummaryRow, getSummaryRowCriteria, getSummaryRowDataSource, getSummaryRowFetchRequestProperties, getSummaryRowHeight, getSummaryRowStyle, getTallBaseStyle, getTitleField, getTitleFieldValue, getToggleFreezeText, getTotalRows, getTrackerImage, getUnfreezeFieldText, getUngroupText, getUnremoveIcon, getUpdateOperation, getUseAdvancedFieldPicker, getUseAllDataSourceFields, getUseCellRollOvers, getUseCopyPasteShortcuts, getUseFlatFields, getUseRemoteValidators, getUseRowSpanStyling, getValidateByCell, getValidateOnChange, getValueIcon, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getViewState, getVirtualScrolling, getVisibleRows, getWaitForSave, getWarnOnRemoval, getWarnOnRemovalMessage, getWarnOnUnmappedValueFieldChange, getWrapCells, groupBy, hasChanges, hasErrors, headerHoverHTML, headerTitleClipped, hideField, hideField, hideFields, hideFields, hideFields, hideFields, invalidateCache, invalidateRecordComponents, isCheckboxField, isExpanded, isExpansionField, isGrouped, isGroupNode, isPartiallySelected, isRowNumberField, isSelected, isSortField, markForRedraw, markForRedraw, markRecordRemoved, markSelectionRemoved, onInit, openRecordDetailGrid, openRecordEditor, preloadImages, recalculateGridSummary, recalculateSummaries, recalculateSummaries, recordClick, recordMarkedAsRemoved, refreshCell, refreshCell, refreshCellStyle, refreshFields, refreshRecordComponent, refreshRecordComponent, refreshRow, removeData, removeData, removeData, removeEmbeddedComponent, removeEmbeddedComponent, removeEmbeddedComponent, removeRecordClick, removeSelectedData, removeSelectedData, reorderField, reorderFields, resizeField, resort, rowClick, rowDoubleClick, rowHasChanges, rowHasErrors, saveAllEdits, saveAllEdits, saveAllEdits, scrollBodyTo, scrollToCell, scrollToColumn, scrollToRow, selectAllRecords, selectRecord, selectRecord, selectRecord, selectRecord, selectRecords, selectRecords, selectRecords, selectRecords, selectSingleRecord, selectSingleRecord, setAddDropValues, setAddFormulaFieldText, setAddOperation, setAddSummaryFieldText, setAdvancedFieldPickerThreshold, setAllowFilterExpressions, setAllowRowSpanning, setAlternateBodyStyleName, setAlternateRecordFrequency, setAlwaysShowEditors, setAnimateFolderEffect, setAnimateFolderMaxRows, setAnimateFolders, setAnimateFolderSpeed, setAnimateFolderTime, setAnimateRemoveRecord, setAnimateRemoveSpeed, setAnimateRemoveTime, setAnimateRollOver, setAnimateRollUnder, setAnimateSelection, setAnimateSelectionUnder, setApplyFormulaAfterSummary, setApplyRowNumberStyle, setArrowKeyAction, setAsynchGroupingPrompt, setAutoFetchAsFilter, setAutoFetchData, setAutoFetchDisplayMap, setAutoFetchTextMatchStyle, setAutoFitAllText, setAutoFitClipFields, setAutoFitData, setAutoFitExpandField, setAutoFitExtraRecords, setAutoFitFieldsFillViewport, setAutoFitFieldText, setAutoFitFieldWidths, setAutoFitHeaderHeights, setAutoFitIconFields, setAutoFitMaxColumns, setAutoFitMaxHeight, setAutoFitMaxRecords, setAutoFitMaxWidth, setAutoFitWidth, setAutoFitWidthApproach, setAutoSaveEdits, setAutoSizeHeaderSpans, setBadFormulaResultValue, setBodyBackgroundColor, setBodyOverflow, setBooleanBaseStyle, setBooleanFalseImage, setBooleanImageHeight, setBooleanImageWidth, setBooleanPartialImage, setBooleanTrueImage, setCanAcceptDroppedRecords, setCanAddFormulaFields, setCanAddSummaryFields, setCanAutoFitFields, setCancelEditingConfirmationMessage, setCanCollapseGroup, setCanDragRecordsOut, setCanDragSelect, setCanDragSelectText, setCanDropInEmptyArea, setCanEdit, setCanEditFieldAttribute, setCanEditTitles, setCanExpandMultipleRecords, setCanExpandRecordProperty, setCanExpandRecords, setCanFreezeFields, setCanGroupBy, setCanHover, setCanMultiGroup, setCanMultiSort, setCanPickFields, setCanPickOmittedFields, setCanRemoveRecords, setCanReorderFields, setCanReorderRecords, setCanResizeFields, setCanSelectAll, setCanSelectCells, setCanSort, setCanTabToHeader, setCellFormatter, setCellPadding, setCellValueHoverFormatter, setChartConstructor, setChartType, setCheckboxFieldFalseImage, setCheckboxFieldImageHeight, setCheckboxFieldImageWidth, setCheckboxFieldPartialImage, setCheckboxFieldProperties, setCheckboxFieldTrueImage, setChildExpansionMode, setClearAllSortingText, setClearFilterText, setClearSortFieldText, setClipHeaderTitles, setConfigureGroupingText, setConfigureSortText, setConfirmCancelEditing, setConfirmDiscardEdits, setConfirmDiscardEditsMessage, setCriteria, setData, setDataFetchMode, setDataPageSize, setDataProperties, setDataSource, setDateFormatter, setDateInputFormat, setDatetimeFormatter, setDefaultFields, setDefaultProperties, setDeferRemoval, setDetailDS, setDetailDS, setDetailField, setDiscardEditsSaveButtonTitle, setDontAutoDestroyComponent, setDragDataAction, setDragTrackerIconCustomizer, setDragTrackerMode, setDragTrackerStyle, setDrawAheadRatio, setDrawAllMaxCells, setDropValues, setDuplicateDragMessage, setEditByCell, setEditEvent, setEditFailedBaseStyle, setEditFailedCSSText, setEditFormulaFieldText, setEditOnF2Keypress, setEditOnFocus, setEditorCustomizer, setEditorValueMap, setEditorValueMap, setEditPendingBaseStyle, setEditPendingCSSText, setEditSummaryFieldText, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValues, setEmptyCellValue, setEmptyMessageStyle, setEnforceVClipping, setEnterKeyEditAction, setEnumCriteriaAsInitialValues, setEscapeKeyEditAction, setExpansionCanEdit, setExpansionEditorSaveDialogPrompt, setExpansionEditorShowSaveDialog, setExpansionFieldFalseImage, setExpansionFieldImageHeight, setExpansionFieldImageWidth, setExpansionFieldTrueImage, setExpansionMode, setExportAll, setExportFields, setExportRawValues, setFastCellUpdates, setFetchDelay, setFetchOperation, setFieldButtonProperties, setFieldCellIcon, setFieldError, setFieldError, setFieldHeaderBaseStyle, setFieldHeaderTitleStyle, setFieldIcon, setFieldPickerFieldProperties, setFieldPickerShowSampleValues, setFields, setFieldState, setFieldTitle, setFieldTitle, setFieldVisibilitySubmenuTitle, setFilterButtonPrompt, setFilterButtonProperties, setFilterByCell, setFilterEditorCriteria, setFilterEditorHeight, setFilterLocalData, setFilterOnKeypress, setFixedFieldWidths, setFixedRecordHeights, setFormulaBuilderSpanTitleSeparator, setFreezeFieldText, setFreezeOnLeftText, setFreezeOnRightText, setFrozenBaseStyle, setFrozenHeaderBaseStyle, setFrozenHeaderTitleStyle, setGenerateClickOnEnter, setGenerateClickOnSpace, setGenerateDoubleClickOnEnter, setGenerateDoubleClickOnSpace, setGridComponents, setGridComponents, setGridSummaryRecordProperty, setGroupByAsyncThreshold, setGroupByField, setGroupByField, setGroupByFieldSummaries, setGroupByMaxRecords, setGroupByText, setGroupIcon, setGroupIconSize, setGroupIndentSize, setGroupLeadingIndent, setGroupNodeBaseStyle, setGroupNodeStyle, setGroupStartOpen, setGroupStartOpen, setGroupState, setGroupSummaryRecordProperty, setGroupSummaryStyle, setGroupTitleColumnProperties, setGroupTitleField, setHeaderAutoFitEvent, setHeaderBackgroundColor, setHeaderBarStyle, setHeaderBaseStyle, setHeaderButtonProperties, setHeaderHeight, setHeaderHoverAlign, setHeaderHoverFormatter, setHeaderHoverHeight, setHeaderHoverOpacity, setHeaderHoverStyle, setHeaderHoverVAlign, setHeaderHoverWidth, setHeaderHoverWrap, setHeaderMenuButtonHeight, setHeaderMenuButtonIcon, setHeaderMenuButtonIconHeight, setHeaderMenuButtonIconWidth, setHeaderMenuButtonWidth, setHeaderSpanBaseStyle, setHeaderSpanButtonProperties, setHeaderSpanHeaderTitle, setHeaderSpanHeight, setHeaderSpans, setHeaderSpanTitle, setHeaderSpanTitleStyle, setHeaderTitleStyle, setHiliteCanReplaceValue, setHiliteEditorSpanTitleSeparator, setHiliteIconHeight, setHiliteIconLeftPadding, setHiliteIconPosition, setHiliteIconRightPadding, setHiliteIcons, setHiliteIconSize, setHiliteIconWidth, setHiliteProperty, setHiliteReplaceValueFieldTitle, setHilites, setHiliteState, setHoverCustomizer, setHoverMode, setHoverStyle, setImageSize, setIncludeHilitesInSummaryFields, setIncludeInSummaryProperty, setInitialCriteria, setInitialSort, setInstantScrollTrackRedraw, setInvalidSummaryValue, setIsSeparatorProperty, setLeaveHeaderMenuButtonSpace, setLeaveScrollbarGap, setLinkTextProperty, setListEndEditAction, setLoadingDataMessage, setLoadingDataMessageStyle, setLoadingMessage, setLocateColumnsBy, setLocateRowsBy, setLogicalStructure, setLongTextEditorThreshold, setLongTextEditorType, setMaxExpandedRecords, setMaxExpandedRecordsPrompt, setMinFieldWidth, setMissingSummaryFieldValue, setModalEditing, setNeverValidate, setNormalBaseStyle, setNormalCellHeight, setNullGroupTitle, setOfflineMessageStyle, setOriginBaseStyle, setPoolComponentsPerColumn, setPreventDuplicates, setPrintAutoFit, setPrintBaseStyle, setPrintHeaderStyle, setPrintMaxRows, setPrintWrapCells, setQuickDrawAheadRatio, setRecordBaseStyleProperty, setRecordCanRemoveProperty, setRecordCanSelectProperty, setRecordComponentHeight, setRecordComponentPoolingMode, setRecordComponentPosition, setRecordDetailDSProperty, setRecordEditProperty, setRecordEnabledProperty, setRecords, setRecordSummaryBaseStyle, setRemovedCSSText, setRemoveFieldProperties, setRemoveFieldTitle, setRemoveIcon, setRemoveIconSize, setRemoveOperation, setReselectOnUpdate, setReselectOnUpdateNotifications, setResizeFieldsInRealTime, setReverseRTLAlign, setRollUnderCanvasProperties, setRowEndEditAction, setRowErrors, setRowNumberFieldProperties, setRowNumberStart, setRowNumberStyle, setRowSpanSelectionMode, setSaveByCell, setSaveLocally, setSaveRequestProperties, setScreenReaderCellSeparator, setScreenReaderRowSeparator, setScrollRedrawDelay, setSelectedState, setSelectHeaderOnSort, setSelectionAppearance, setSelectionCanvasProperties, setSelectionProperty, setSelectionType, setSelectionUnderCanvasProperties, setSelectOnEdit, setShowAllColumns, setShowAllRecords, setShowAsynchGroupingPrompt, setShowBackgroundComponents, setShowCellContextMenus, setShowClippedHeaderTitlesOnHover, setShowClippedValuesOnHover, setShowCollapsedGroupSummary, setShowComplexFields, setShowDetailFields, setShowEmptyMessage, setShowFilterEditor, setShowGridSummary, setShowGroupSummary, setShowGroupSummaryInHeader, setShowGroupTitleColumn, setShowHeader, setShowHeaderContextMenu, setShowHeaderMenuButton, setShowHeaderSpanTitlesInFormulaBuilder, setShowHeaderSpanTitlesInHiliteEditor, setShowHeaderSpanTitlesInSortEditor, setShowHiddenFields, setShowHilitesInGroupSummary, setShowHover, setShowHoverComponents, setShowRecordComponents, setShowRecordComponentsByCell, setShowRollOver, setShowRollOverCanvas, setShowRowNumbers, setShowSelectedStyle, setShowSelectionCanvas, setShowSortArrow, setShowSortNumerals, setShowTreeColumnPicker, setShrinkForFreeze, setSingleCellValueProperty, setSkinImgDir, setSort, setSortAscendingImage, setSortDescendingImage, setSortDirection, setSortEditorSpanTitleSeparator, setSorterButtonTitle, setSortField, setSortField, setSortFieldAscendingText, setSortFieldDescendingText, setSortNumeralStyle, setSortState, setStopOnErrors, setStyleName, setSummaryRowCriteria, setSummaryRowDataSource, setSummaryRowFetchRequestProperties, setSummaryRowHeight, setSummaryRowStyle, setTallBaseStyle, setTitleField, setTrackerImage, setUnfreezeFieldText, setUngroupText, setUnremoveIcon, setUpdateOperation, setUseAdvancedFieldPicker, setUseAllDataSourceFields, setUseCellRollOvers, setUseCopyPasteShortcuts, setUseFlatFields, setUseRemoteValidators, setUseRowSpanStyling, setValidateByCell, setValidateOnChange, setValueIconHeight, setValueIconLeftPadding, setValueIconRightPadding, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setViewState, setVirtualScrolling, setWaitForSave, setWarnOnRemoval, setWarnOnRemovalMessage, setWarnOnUnmappedValueFieldChange, setWrapCells, shouldIncludeHiliteInSummaryField, showField, showField, showFields, showFields, showFields, showFields, showRecordComponent, sort, sort, sort, startEditing, startEditing, startEditing, startEditing, startEditingNew, startEditingNew, startEditingNew, stopHover, summaryUpdated, toggleSort, transferSelectedData, transferSelectedData, unfreezeField, unfreezeField, unfreezeFields, unfreezeFields, ungroup, unmarkRecordRemoved, unsort, updateData, updateData, updateData, updateRecordComponent, userSelectAllRecords, validateCell, validateCell, validateRow, willAcceptDrop, willFetchData, willFetchData`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutTopMargin, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOffset, getMemberOverlap, getMembers, getMembersMargin, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, membersChanged, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutTopMargin, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getKeepInParentRect, getLayoutAlign, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinWidth, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowResizeBar, getShowShadow, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapResizeToGrid, getSnapTo, getSnapToGrid, getSnapVDirection, getSnapVGap, getTabIndex, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseOpacityFilter, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, handleHover, hide, hideClickMask, hideClickMask, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, parentResized, printComponents, redraw, redraw, removeChild, removeChild, removePeer, removePeer, resizeBy, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAllowExternalFilters, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanSelectText, setCanvasItem, setChildren, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultProperties, setDisabled, setDisabledCursor, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlPosition, setImage, setImage, setIsGroup, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinWidth, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setOpacity, setPadding, setPageLeft, setPageTop, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowResizeBar, setShowShadow, setSmoothFade, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToGrid, setSnapTo, setSnapToGrid, setSnapVDirection, setSnapVGap, setTabIndex, setTooltip, setTop, setTop, setUseBackMask, setUseOpacityFilter, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateHover, updateHover, updateShadow, visibleAtPoint`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getElement, getElement, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setElement, setHtmlElement, setID, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent, unsinkEvents`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

    - ### Methods inherited from interface com.smartgwt.client.widgets.DataBoundComponent

      `getOrCreateJsObj`

- - ### Constructor Detail

    - #### Menu

          public Menu()

    - #### Menu

          public Menu(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static Menu getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### getTestInstance

          protected Menu getTestInstance()

      Overrides:
        `getTestInstance` in class `ListGrid`

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `ListGrid`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `ListGrid`

    - #### setAlternateRecordStyles

          public void setAlternateRecordStyles(java.lang.Boolean alternateRecordStyles)

      Explicitly disable alternateRecordStyles at the menu level by default so setting to true for all ListGrids will not impact menus' appearance.
      Overrides:
        `setAlternateRecordStyles` in class `ListGrid`
      Parameters:
        `alternateRecordStyles` - alternateRecordStyles Default value is false
      See Also:
        Grid cells Example

    - #### getAlternateRecordStyles

          public java.lang.Boolean getAlternateRecordStyles()

      Explicitly disable alternateRecordStyles at the menu level by default so setting to true for all ListGrids will not impact menus' appearance.
      Overrides:
        `getAlternateRecordStyles` in class `ListGrid`
      Returns:
        Boolean
      See Also:
        Grid cells Example

    - #### setAutoDismiss

          public void setAutoDismiss(java.lang.Boolean autoDismiss)

      When false, when a menu item is chosen (via mouse click or keyboard), the menu is not automatically hidden, staying in place for further interactivity
      Parameters:
        `autoDismiss` - autoDismiss Default value is true
      See Also:
        `setCascadeAutoDismiss(java.lang.Boolean)`

    - #### getAutoDismiss

          public java.lang.Boolean getAutoDismiss()

      When false, when a menu item is chosen (via mouse click or keyboard), the menu is not automatically hidden, staying in place for further interactivity
      Returns:
        Boolean
      See Also:
        `getCascadeAutoDismiss()`

    - #### setAutoDismissOnBlur

          public void setAutoDismissOnBlur(java.lang.Boolean autoDismissOnBlur)

      When false, when a user clicks outside the menu, or hits the Escape key, this menu will not be automatically hidden, staying in place for further interactivity.
      Parameters:
        `autoDismissOnBlur` - autoDismissOnBlur Default value is true

    - #### getAutoDismissOnBlur

          public java.lang.Boolean getAutoDismissOnBlur()

      When false, when a user clicks outside the menu, or hits the Escape key, this menu will not be automatically hidden, staying in place for further interactivity.
      Returns:
        Boolean

    - #### setAutoDraw

          public void setAutoDraw(java.lang.Boolean autoDraw)

      Menus will not draw on initialization, until they're explicitly show()n

      Note : This is an advanced setting

      Overrides:
        `setAutoDraw` in class `Canvas`
      Parameters:
        `autoDraw` - autoDraw Default value is false
      See Also:
        `Drawing overview and related methods`

    - #### getAutoDraw

          public java.lang.Boolean getAutoDraw()

      Menus will not draw on initialization, until they're explicitly show()n
      Overrides:
        `getAutoDraw` in class `Canvas`
      Returns:
        Boolean
      See Also:
        `Drawing overview and related methods`

    - #### setBaseStyle

          public void setBaseStyle(java.lang.String baseStyle)

      CSS style for a normal cell
      Overrides:
        `setBaseStyle` in class `ListGrid`
      Parameters:
        `baseStyle` - . See `CSSStyleName`. Default value is "menu"
      See Also:
        `Appearance overview and related methods`

    - #### getBaseStyle

          public java.lang.String getBaseStyle()

      CSS style for a normal cell
      Overrides:
        `getBaseStyle` in class `ListGrid`
      Returns:
        . See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setBodyStyleName

          public void setBodyStyleName(java.lang.String bodyStyleName)

      CSS style used for the body of this menu when there is no icon field. When there is an icon field, then `iconBodyStyleName`, if set, will override this setting.

      If applying a background-color to the body via a CSS style applied using this property, be sure to set `bodyBackgroundColor` to `null`.

      Overrides:
        `setBodyStyleName` in class `ListGrid`
      Parameters:
        `bodyStyleName` - . See `CSSStyleName`. Default value is "normal"
      See Also:
        `Appearance overview and related methods`

    - #### getBodyStyleName

          public java.lang.String getBodyStyleName()

      CSS style used for the body of this menu when there is no icon field. When there is an icon field, then `iconBodyStyleName`, if set, will override this setting.

      If applying a background-color to the body via a CSS style applied using this property, be sure to set `bodyBackgroundColor` to `null`.

      Overrides:
        `getBodyStyleName` in class `ListGrid`
      Returns:
        . See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setCanSelectParentItems

          public void setCanSelectParentItems(java.lang.Boolean canSelectParentItems)

      If true, clicking or pressing Enter on a menu item that has a submenu will select that item (with standard behavior of hiding the menus, calling click handlers, etc) instead of showing the submenu.
      Parameters:
        `canSelectParentItems` - canSelectParentItems Default value is null
      See Also:
        `Selection overview and related methods`, Tree Binding Example

    - #### getCanSelectParentItems

          public java.lang.Boolean getCanSelectParentItems()

      If true, clicking or pressing Enter on a menu item that has a submenu will select that item (with standard behavior of hiding the menus, calling click handlers, etc) instead of showing the submenu.
      Returns:
        Boolean
      See Also:
        `Selection overview and related methods`, Tree Binding Example

    - #### setCascadeAutoDismiss

          public void setCascadeAutoDismiss(java.lang.Boolean cascadeAutoDismiss)

      When true any generated submenus will inherit `autoDismiss` from this menu.
      Parameters:
        `cascadeAutoDismiss` - cascadeAutoDismiss Default value is true

    - #### getCascadeAutoDismiss

          public java.lang.Boolean getCascadeAutoDismiss()

      When true any generated submenus will inherit `autoDismiss` from this menu.
      Returns:
        Boolean

    - #### setCellHeight

          public void setCellHeight(int cellHeight)

      The height of each item in the menu, in pixels.
      Overrides:
        `setCellHeight` in class `ListGrid`
      Parameters:
        `cellHeight` - cellHeight Default value is 20
      See Also:
        `Sizing overview and related methods`

    - #### getCellHeight

          public int getCellHeight()

      The height of each item in the menu, in pixels.
      Overrides:
        `getCellHeight` in class `ListGrid`
      Returns:
        int
      See Also:
        `Sizing overview and related methods`

    - #### setDataSource

          public void setDataSource(DataSource dataSource)
                             throws java.lang.IllegalStateException

      Optional DataSource to fetch menuItems and submenus from, instead of using `data`/menu.items.

      The provided DataSource must be set up for hierarchical fetching - see the `Tree Data Binding overview`.

      Specified by:
        `setDataSource` in interface `DataBoundComponent`
      Overrides:
        `setDataSource` in class `ListGrid`
      Parameters:
        `dataSource` - dataSource Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDataSource

          public DataSource getDataSource()

      Optional DataSource to fetch menuItems and submenus from, instead of using `data`/menu.items.

      The provided DataSource must be set up for hierarchical fetching - see the `Tree Data Binding overview`.

      Specified by:
        `getDataSource` in interface `DataBoundComponent`
      Overrides:
        `getDataSource` in class `ListGrid`
      Returns:
        DataSource

    - #### setDefaultWidth

          public void setDefaultWidth(int defaultWidth)

      The default menu width.
      Overrides:
        `setDefaultWidth` in class `Canvas`
      Parameters:
        `defaultWidth` - defaultWidth Default value is 150
      See Also:
        `Sizing overview and related methods`

    - #### getDefaultWidth

          public int getDefaultWidth()

      The default menu width.
      Overrides:
        `getDefaultWidth` in class `Canvas`
      Returns:
        int
      See Also:
        `Sizing overview and related methods`

    - #### setEmptyMessage

          public void setEmptyMessage(java.lang.String emptyMessage)

      Message to show when a menu is shown with no items.

      Note : This is an advanced setting

      Overrides:
        `setEmptyMessage` in class `ListGrid`
      Parameters:
        `emptyMessage` - . See `HTMLString`. Default value is "[Empty menu]"
      See Also:
        `ListGrid.setShowEmptyMessage(java.lang.Boolean)`, `ListGrid.setEmptyMessageStyle(java.lang.String)`, Empty grid Example

    - #### getEmptyMessage

          public java.lang.String getEmptyMessage()

      Message to show when a menu is shown with no items.
      Overrides:
        `getEmptyMessage` in class `ListGrid`
      Returns:
        . See `HTMLString`
      See Also:
        `ListGrid.getShowEmptyMessage()`, `ListGrid.getEmptyMessageStyle()`, Empty grid Example

    - #### setFetchSubmenus

          public void setFetchSubmenus(java.lang.Boolean fetchSubmenus)
                                throws java.lang.IllegalStateException

      When using a Tree or hierarchical DataSource as the menu's data, submenus are automatically generated from child nodes. `fetchSubmenus` can be set to false to disable this for the whole menu, or can be set false on a per-item basis via `fetchSubmenus`.
      Parameters:
        `fetchSubmenus` - fetchSubmenus Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFetchSubmenus

          public java.lang.Boolean getFetchSubmenus()

      When using a Tree or hierarchical DataSource as the menu's data, submenus are automatically generated from child nodes. `fetchSubmenus` can be set to false to disable this for the whole menu, or can be set false on a per-item basis via `fetchSubmenus`.
      Returns:
        Boolean

    - #### setIconBodyStyleName

          public void setIconBodyStyleName(java.lang.String iconBodyStyleName)
                                    throws java.lang.IllegalStateException

      If set, the CSS style used for the body of this menu when there is an icon field. In RTL mode, the iconBodyStyleName is suffixed with "RTL", which allows skins to apply different styles in LTR and RTL modes.

      Note: Any skin which uses iconBodyStyleName should add "RTL" styles as well, even if identical to LTR styles. Otherwise, menus may lose their styling in RTL mode.

      Parameters:
        `iconBodyStyleName` - . See `CSSStyleName`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getIconBodyStyleName

          public java.lang.String getIconBodyStyleName()

      If set, the CSS style used for the body of this menu when there is an icon field. In RTL mode, the iconBodyStyleName is suffixed with "RTL", which allows skins to apply different styles in LTR and RTL modes.

      Note: Any skin which uses iconBodyStyleName should add "RTL" styles as well, even if identical to LTR styles. Otherwise, menus may lose their styling in RTL mode.

      Returns:
        . See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setIconHeight

          public void setIconHeight(int iconHeight)

      The default height applied to custom icons in this menu. This is used whenever item.iconHeight is not specified.
      Parameters:
        `iconHeight` - iconHeight Default value is 16

    - #### getIconHeight

          public int getIconHeight()

      The default height applied to custom icons in this menu. This is used whenever item.iconHeight is not specified.
      Returns:
        int

    - #### setIconWidth

          public void setIconWidth(int iconWidth)

      The default width applied to custom icons in this menu. This is used whenever item.iconWidth is not specified.
      Parameters:
        `iconWidth` - iconWidth Default value is 16

    - #### getIconWidth

          public int getIconWidth()

      The default width applied to custom icons in this menu. This is used whenever item.iconWidth is not specified.
      Returns:
        int

    - #### setMenuButtonWidth

          public void setMenuButtonWidth(java.lang.Integer menuButtonWidth)
                                  throws java.lang.IllegalStateException

      For a menu that has a `MenuButton` generated for it automatically (for example when included in a `MenuBar`, the width that the MenuButton should have. If unset, the MenuButton will be as wide as `menu.width`.
      Parameters:
        `menuButtonWidth` - menuButtonWidth Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMenuButtonWidth

          public java.lang.Integer getMenuButtonWidth()

      For a menu that has a `MenuButton` generated for it automatically (for example when included in a `MenuBar`, the width that the MenuButton should have. If unset, the MenuButton will be as wide as `menu.width`.
      Returns:
        Integer

    - #### setShowAnimationEffect

          public void setShowAnimationEffect(java.lang.String showAnimationEffect)

      When this menu is shown how should it animate into view? By default the menu will just show at the specified size/position. Options for animated show effects are `"fade"` to fade from transparent to visible, `"slide"` to slide the menu into view, or `"wipe"` to have the menu grow into view, revealing its content as it grows. Can be overridden by passing the 'animationEffect' parameter to 'menu.show()'

      Note : This is an advanced setting

      Parameters:
        `showAnimationEffect` - . See `String`. Default value is null

    - #### getShowAnimationEffect

          public java.lang.String getShowAnimationEffect()

      When this menu is shown how should it animate into view? By default the menu will just show at the specified size/position. Options for animated show effects are `"fade"` to fade from transparent to visible, `"slide"` to slide the menu into view, or `"wipe"` to have the menu grow into view, revealing its content as it grows. Can be overridden by passing the 'animationEffect' parameter to 'menu.show()'
      Returns:
        . See `String`

    - #### setShowIcons

          public void setShowIcons(java.lang.Boolean showIcons)

      A boolean, indicating whether the checkmark/custom icon column should be displayed. If showIcons is not set, the menu will show the icon column only if one of its items specifies an icon, checked, checkIf, or dynamicIcon property.
      Parameters:
        `showIcons` - showIcons Default value is true

    - #### getShowIcons

          public java.lang.Boolean getShowIcons()

      A boolean, indicating whether the checkmark/custom icon column should be displayed. If showIcons is not set, the menu will show the icon column only if one of its items specifies an icon, checked, checkIf, or dynamicIcon property.
      Returns:
        Boolean

    - #### setShowKeys

          public void setShowKeys(java.lang.Boolean showKeys)

      A boolean, indicating whether the shortcut key column should be displayed. If showKeys is not set, the menu will show the key column only if one of its items specifies a keys property. If showKeys is false, the keys will not be displayed, but will still function.
      Parameters:
        `showKeys` - showKeys Default value is true

    - #### getShowKeys

          public java.lang.Boolean getShowKeys()

      A boolean, indicating whether the shortcut key column should be displayed. If showKeys is not set, the menu will show the key column only if one of its items specifies a keys property. If showKeys is false, the keys will not be displayed, but will still function.
      Returns:
        Boolean

    - #### setShowSubmenus

          public void setShowSubmenus(java.lang.Boolean showSubmenus)

      A boolean, indicating whether the submenu indicator column should be displayed. If showSubmenus is not set, the menu will show the indicator column only if one of its items specifies a submenu property. If showSubmenus is false, the submenu arrows will not be displayed, but submenus will still appear on rollover.
      Parameters:
        `showSubmenus` - showSubmenus Default value is true

    - #### getShowSubmenus

          public java.lang.Boolean getShowSubmenus()

      A boolean, indicating whether the submenu indicator column should be displayed. If showSubmenus is not set, the menu will show the indicator column only if one of its items specifies a submenu property. If showSubmenus is false, the submenu arrows will not be displayed, but submenus will still appear on rollover.
      Returns:
        Boolean

    - #### setSubmenuConstructor

          public void setSubmenuConstructor(java.lang.String submenuConstructor)
                                     throws java.lang.IllegalStateException

      When using a Tree or hierarchical DataSource as the menu's data, optional subclass of Menu that should be used when generating submenus.
      Parameters:
        `submenuConstructor` - . See `SCClassName`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getSubmenuConstructor

          public java.lang.String getSubmenuConstructor()

      When using a Tree or hierarchical DataSource as the menu's data, optional subclass of Menu that should be used when generating submenus.
      Returns:
        . See `SCClassName`

    - #### setSubmenuDirection

          public void setSubmenuDirection(java.lang.String submenuDirection)

      Should submenus show up on our left or right. Can validly be set to `"left"` or `"right"`. If unset, submenus show up on the right by default in Left-to-right text mode, or on the left in Right-to-left text mode (see `Page.isRTL`).
      Parameters:
        `submenuDirection` - . See `String`. Default value is null

    - #### getSubmenuDirection

          public java.lang.String getSubmenuDirection()

      Should submenus show up on our left or right. Can validly be set to `"left"` or `"right"`. If unset, submenus show up on the right by default in Left-to-right text mode, or on the left in Right-to-left text mode (see `Page.isRTL`).
      Returns:
        . See `String`

    - #### setTarget

          public void setTarget(Canvas target)

      Optional target canvas for this menu. Available as a parameter to dynamic menuItem configuration methods such as `MenuItem.checkIf`.

      Whenever a Menu is shown as a contextMenu by a widget due to `contextMenu` being set, `menu.target` is automatically set to the widget that showed the contextMenu.

      If this item has any `submenus` the `target` will be propagated down to these child menus.

      Parameters:
        `target` - target Default value is null

    - #### getTarget

          public Canvas getTarget()

      Optional target canvas for this menu. Available as a parameter to dynamic menuItem configuration methods such as `MenuItem.checkIf`.

      Whenever a Menu is shown as a contextMenu by a widget due to `contextMenu` being set, `menu.target` is automatically set to the widget that showed the contextMenu.

      If this item has any `submenus` the `target` will be propagated down to these child menus.

      Returns:
        Canvas

    - #### setUseKeys

          public void setUseKeys(java.lang.Boolean useKeys)

      A boolean indicating whether this menu should use shortcut keys. Set useKeys to false in a menu's initialization block to explicitly disable shortcut keys.
      Parameters:
        `useKeys` - useKeys Default value is true

    - #### getUseKeys

          public java.lang.Boolean getUseKeys()

      A boolean indicating whether this menu should use shortcut keys. Set useKeys to false in a menu's initialization block to explicitly disable shortcut keys.
      Returns:
        Boolean

    - #### getItem

          public MenuItem getItem(int item)

      Get a particular MenuItem by index.

      If passed a MenuItem, returns it.

      Parameters:
        `item` - index of the MenuItem
      Returns:
        the MenuItem, Pointer to the item, or null if not defined

    - #### hideContextMenu

          public void hideContextMenu()

      Hide the context menu - alias for hide()
      Overrides:
        `hideContextMenu` in class `Canvas`
      See Also:
        `Visibility overview and related methods`

    - #### addItemClickHandler

          public com.google.gwt.event.shared.HandlerRegistration addItemClickHandler(ItemClickHandler handler)

      Add a itemClick handler.

      Executed when a menu item with no click handler is clicked by the user. This itemClick handler must be specified as a function. It is passed an item parameter that is a reference to the clicked menu item.

      Specified by:
        `addItemClickHandler` in interface `HasItemClickHandlers`
      Parameters:
        `handler` - the itemClick handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### showContextMenu

          public java.lang.Boolean showContextMenu()

      Show this menu as a context menu, that is, immediately adjacent to the current mouse position.
      Returns:
        false == stop processing this event
      See Also:
        `Visibility overview and related methods`

    - #### hideAllMenus

          public static void hideAllMenus()

      Hide all menus that are currently open. This method is useful to hide the current set of menus including submenus, and dismiss the menu's clickMask.

    - #### setDefaultProperties

          public static void setDefaultProperties(Menu menuProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `menuProperties` - properties that should be used as new defaults when instances of this class are created

    - #### onInit_ListGrid

          protected void onInit_ListGrid()

      Overrides:
        `onInit_ListGrid` in class `ListGrid`

    - #### setData

          public void setData(MenuItem... data)

      An array of menuItem objects, specifying the menu items this menu should show.
      Parameters:
        `data` - menu items

    - #### setData

          public void setData(Record[] data)

      An array of Record objects, specifying the data to be used to populate the DataBoundComponent. Note that not all DataBoundComponents observe the changes to the data to redraw themselves. Refer to the version of setData that accepts component specific records.
      Overrides:
        `setData` in class `ListGrid`
      Parameters:
        `data` - array of Record objects.
      See Also:
        `setData(MenuItem[])`

    - #### setData

          public void setData(Tree data)

      Display a hierarchical set of menu items and submenus based on a Tree of data.
      Parameters:
        `data` - Tree

    - #### setData

          public void setData(RecordList data)

      An List of Record objects, specifying the data to be used to populate the DataBoundComponent. Note that not all DataBoundComponents observe the changes to the data to redraw themselves. Refer to the version of setData that accepts component specific records.
      Overrides:
        `setData` in class `ListGrid`
      Parameters:
        `data` - List of Records

    - #### setItems

          public void setItems(MenuItem... items)

      Synonym for `data` Synonym for `setData(com.smartgwt.client.widgets.menu.MenuItem...)`.
      Parameters:
        `items` - new items for this menu. Default value is null

    - #### getItems

          public MenuItem[] getItems()

      Return the menu items.
      Returns:
        the menu items

    - #### setTitle

          public void setTitle(java.lang.String title)

      When used in a MenuBar, the title of the menu button create will be the title of the Menu.
      Overrides:
        `setTitle` in class `Canvas`
      Parameters:
        `title` - the title

    - #### removeItem

          public void removeItem(MenuItem item)

    - #### addItem

          public void addItem(MenuItem item)

    - #### addItem

          public void addItem(MenuItem item,
                     int index)

    - #### getItemNum

          public int getItemNum(MenuItem item)

      Given a MenuItem, return it's index in the items array.
      Parameters:
        `item` - the MenuItem
      Returns:
        index of the item, or -1 if not defined.

    - #### setItemProperties

          public void setItemProperties(int item,
                               MenuItem properties)

      Set arbitrary properties for a particular menu item.
      Parameters:
        `item` - index of the MenuItem
        `properties` - properties to apply to the item

    - #### setItemChecked

          public java.lang.Boolean setItemChecked(MenuItem item)

      Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the checked state.
      Parameters:
        `item` - MenuItem in question, or it's index
      Returns:
        true if the checked state was changed

    - #### setItemChecked

          public java.lang.Boolean setItemChecked(int item)

      Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the checked state.
      Parameters:
        `item` - MenuItem in question, or it's index
      Returns:
        true if the checked state was changed

    - #### setItemChecked

          public java.lang.Boolean setItemChecked(MenuItem item,
                                         boolean newState)

      Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the checked state.
      Parameters:
        `item` - MenuItem in question, or it's index
        `newState` - true to check the menu item, false to uncheck it. If not passed, true is assumed
      Returns:
        true if the checked state was changed

    - #### setItemChecked

          public java.lang.Boolean setItemChecked(int item,
                                         boolean newState)

      Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the checked state.
      Parameters:
        `item` - MenuItem in question, or it's index
        `newState` - true to check the menu item, false to uncheck it. If not passed, true is assumed
      Returns:
        true if the checked state was changed

    - #### setItemEnabled

          public java.lang.Boolean setItemEnabled(MenuItem item)

      Enables or disables the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the enabled state.
      Parameters:
        `item` - MenuItem in question, or it's index
      Returns:
        true if the enabled state was changed

    - #### setItemEnabled

          public java.lang.Boolean setItemEnabled(int item)

      Enables or disables the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the enabled state.
      Parameters:
        `item` - MenuItem in question, or it's index
      Returns:
        true if the enabled state was changed

    - #### setItemEnabled

          public java.lang.Boolean setItemEnabled(MenuItem item,
                                         boolean newState)

      Enables or disables the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the enabled state.
      Parameters:
        `item` - MenuItem in question, or it's index
        `newState` - true to enable the menu item, false to disable it. If not passed, true is assumed
      Returns:
        true if the enabled state was changed

    - #### setItemEnabled

          public java.lang.Boolean setItemEnabled(int item,
                                         boolean newState)

      Enables or disables the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the enabled state.
      Parameters:
        `item` - MenuItem in question, or it's index
        `newState` - true to enable the menu item, false to disable it. If not passed, true is assumed
      Returns:
        true if the enabled state was changed

    - #### setItemIcon

          public java.lang.Boolean setItemIcon(MenuItem item,
                                      java.lang.String newIcon)

      Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary. Returns true if the icon changed.
      Parameters:
        `item` - MenuItem in question, or it's index
        `newIcon` - new icon URL
      Returns:
        true == something changed, redraw is called for

    - #### setItemIcon

          public java.lang.Boolean setItemIcon(int item,
                                      java.lang.String newIcon)

      Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary. Returns true if the icon changed.
      Parameters:
        `item` - MenuItem in question, or it's index
        `newIcon` - new icon URL
      Returns:
        true == something changed, redraw is called for

    - #### setItemIcon

          public java.lang.Boolean setItemIcon(MenuItem item,
                                      java.lang.String newIcon,
                                      java.lang.String newDisabledIcon)

      Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary. Returns true if the icon changed.
      Parameters:
        `item` - MenuItem in question, or it's index
        `newIcon` - new icon URL
        `newDisabledIcon` - new icon URL for disabled image
      Returns:
        true == something changed, redraw is called for

    - #### setItemIcon

          public java.lang.Boolean setItemIcon(int item,
                                      java.lang.String newIcon,
                                      java.lang.String newDisabledIcon)

      Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary. Returns true if the icon changed.
      Parameters:
        `item` - MenuItem in question, or it's index
        `newIcon` - new icon URL
        `newDisabledIcon` - new icon URL for disabled image
      Returns:
        true == something changed, redraw is called for

    - #### setItemTitle

          public java.lang.Boolean setItemTitle(MenuItem item,
                                       java.lang.String newTitle)

      Sets the title of a particular menu item to the string specified by newTitle and redraws the menu if necessary.
      Parameters:
        `item` - MenuItem in question, or it's index
        `newTitle` - new title
      Returns:
        true if the title was changed, and false otherwise

    - #### setItemTitle

          public java.lang.Boolean setItemTitle(int item,
                                       java.lang.String newTitle)

      Sets the title of a particular menu item to the string specified by newTitle and redraws the menu if necessary.
      Parameters:
        `item` - MenuItem in question, or it's index
        `newTitle` - new title
      Returns:
        true if the title was changed, and false otherwise

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.menu.MenuLogicalStructure s)

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `ListGrid`